using System.Text.Json.Serialization;

namespace View_by_Distance.Shared.Models;

public record class SortingContainer : Properties.ISortingContainer
{

    public Mapping Mapping { init; get; }
    public Sorting Sorting { init; get; }

    [JsonConstructor]
    public SortingContainer(Mapping mapping, Sorting sorting)
    {
        Mapping = mapping;
        Sorting = sorting;
    }

    public override string ToString()
    {
        string result = string.Concat(Mapping.MappingFromItem.Id, '\t', Mapping.MappingFromLocation?.WholePercentages, '\t', Sorting.Id, '\t', Sorting.WholePercentages, '\t', Sorting.Older, '\t', '\t', Sorting.DistancePermyriad, '\t', Sorting.DaysDelta);
        return result;
    }

}